<template>
  <section
    v-if="shown"
    class="fixed inset-0 [&>*]:absolute [&>*]:inset-0"
  >
    <div class="bg-black opacity-20 blur-2xl" />
    <div class="flex max-w-full items-center justify-center p-10">
      <div class="overflow-auto rounded-lg bg-white [&>*]:px-6">
        <header
          class="flex items-center gap-x-3 border-b border-slate-100 bg-slate-50 pb-2 pt-4 text-slate-600"
        >
          <h4 class="grow">
            <slot name="title" />
          </h4>
          <button
            class="group relative h-6 w-6 transition-transform hover:scale-105 active:scale-90 [&_span]:pointer-events-none [&_span]:block [&_span]:h-1 [&_span]:rounded-md [&_span]:bg-slate-600 [&_span]:transition-all"
            @click="$emit('close')"
          >
            <span
              class="absolute left-0 top-2.5 w-full -rotate-45 group-hover:bg-fuchsia-500"
            />
            <span
              class="absolute left-0 top-2.5 w-full rotate-45 group-hover:bg-fuchsia-500"
            />
          </button>
        </header>
        <section class="pb-10 pt-8">
          <slot />
        </section>
      </div>
    </div>
  </section>
</template>

<script lang="ts" setup>
withDefaults(
  defineProps<{
    shown: boolean;
  }>(),
  { shown: true },
);
defineEmits<{
  (e: 'close'): void;
}>();
</script>
